#CALL excel_multiple_cells_join();

DROP PROCEDURE IF EXISTS excel_multiple_cells_join;

DELIMITER $$

CREATE DEFINER=`root`@`localhost` PROCEDURE `excel_multiple_cells_join`()
BEGIN
	DECLARE _counter BIGINT DEFAULT 0;
    DECLARE _row_id BIGINT DEFAULT 0;
    
    
# --- 1 ---------------------------------------------------------------------------------------

	#Insertamos los registros en la tabla principal
	INSERT INTO `persona`
	(
		`id`,
		`Nombre`,
		`Apellido`,
		`Peso`,
		`Edad`
	)
	SELECT 
		#`Counter`,
		`ID`,
		`Nombre`,
		`Apellido`,
		#`Entrenamiento`,
		`Peso`,
		`Edad`
		#`Contacto`
	FROM `datos_excel`
	WHERE ID <> 0;

        
        
# --- 2 ---------------------------------------------------------------------------------------
    
	#Tabla temporal para guardar los datos de N:N y 1:N
	DROP TABLE IF EXISTS tt_datos;
	CREATE TEMPORARY TABLE tt_datos (datos_id int(11), id_registro int(11), entrenamiento varchar(100), contacto varchar(100));

    # cantidad de registro en la tabla datos_exel
    SELECT @max_counter:= Count(datos_excel_id) FROM datos_excel;
	SET _counter=0;
    
    #Guardamos los valores de las listas en una tb temporal y añadimos el id corespondiente
	my_loop: LOOP
		SET _counter=_counter+1;

		IF _counter > @max_counter THEN
		  LEAVE my_loop;
		END IF;
		
        IF (SELECT IF(ID = 0, true, false) as result FROM datos_excel WHERE datos_excel_id = _counter) THEN
			SET _row_id = _row_id;
		ELSE
			 SET _row_id = _row_id+1;
		END IF;
    
    
		INSERT INTO tt_datos (datos_id, id_registro, entrenamiento, contacto)
			SELECT 
				_counter,
				_row_id as id,
                Entrenamiento,
                Contacto
			  FROM datos_excel WHERE datos_excel_id = _counter;
              
	END LOOP my_loop;
    
    SELECT * FROM tt_datos;
    
    
        
# --- 3 ---------------------------------------------------------------------------------------
    
    #SET FOREIGN_KEY_CHECKS=0;
    
    #ahora que tenemos los registro con id, tratamos cada campo por separado
	SET _counter = 0;
    # cantidad de registro en la tabla datos_exel
    SELECT @max_counter:= Count(datos_id) FROM tt_datos;
    

    # ENTRENAMIENTO
	my_loop: LOOP
		SET _counter=_counter+1;

		IF _counter > @max_counter THEN
		  LEAVE my_loop;
		END IF;
        
        
	  # Campo ENTRENAMIENTO
        IF (SELECT IF(count(entrenamiento) > 0, true, false) FROM tt_datos WHERE datos_id = _counter) THEN
			INSERT INTO persona_tiene_entrenamiento (persona_id, entrenamiento_id)
				SELECT 
					tt.id_registro,
					(SELECT id FROM entrenamientos WHERE Nombre = tt.entrenamiento) 
				  FROM tt_datos tt WHERE tt.datos_id = _counter;
		END IF;
		
        
	  # Campo CONTACTO
        IF (SELECT IF(count(contacto) > 0, true, false) FROM tt_datos WHERE datos_id = _counter) THEN
			INSERT INTO contactos (persona_id, contacto)
				SELECT 
					tt.id_registro AS persona_id,
					contacto
				  FROM tt_datos tt WHERE tt.datos_id = _counter;
		END IF;
              
	END LOOP my_loop;
    
    #SET FOREIGN_KEY_CHECKS=1;
    
    
    
    
    
END; $$
DELIMITER ;


